<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">

<html>

<head>

<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">

<title>Debian Perl Policy - Programs Embedding Perl</title>

<link href="index.html" rel="start">
<link href="ch-programs.html" rel="prev">
<link href="ap-perl6.html" rel="next">
<link href="index.html#contents" rel="contents">
<link href="index.html#copyright" rel="copyright">
<link href="ch1.html" rel="chapter" title="1 About this document">
<link href="ch-perl.html" rel="chapter" title="2 Perl Packaging">
<link href="ch-site.html" rel="chapter" title="3 Locally Installed Modules">
<link href="ch-module_packages.html" rel="chapter" title="4 Packaged Modules">
<link href="ch-programs.html" rel="chapter" title="5 Perl Programs">
<link href="ch-embed.html" rel="chapter" title="6 Programs Embedding Perl">
<link href="ap-perl6.html" rel="appendix" title="A Perl 6">
<link href="ch-perl.html#s-versions" rel="section" title="2.1 Versions">
<link href="ch-perl.html#s-base" rel="section" title="2.2 Base Package">
<link href="ch-perl.html#s-paths" rel="section" title="2.3 Module Path">
<link href="ch-perl.html#s-docs" rel="section" title="2.4 Documentation">
<link href="ch-site.html#s-site_dirs" rel="section" title="3.1 Site Directories">
<link href="ch-site.html#s-site_install" rel="section" title="3.2 Site Installation">
<link href="ch-module_packages.html#s-vendor_dirs" rel="section" title="4.1 Vendor Directories">
<link href="ch-module_packages.html#s-package_names" rel="section" title="4.2 Module Package Names">
<link href="ch-module_packages.html#s-vendor_install" rel="section" title="4.3 Vendor Installation">
<link href="ch-module_packages.html#s-module_deps" rel="section" title="4.4 Module Dependencies">
<link href="ch-programs.html#s-hash_bang" rel="section" title="5.1 Script Magic">
<link href="ch-programs.html#s-program_deps" rel="section" title="5.2 Program Dependencies">
<link href="ch-embed.html#s-build_embedded" rel="section" title="6.1 Building Embedded Programs">
<link href="ch-embed.html#s-embedded_deps" rel="section" title="6.2 Embedded Perl Dependencies">
<link href="ch-embed.html#s-perl_upgrades" rel="section" title="6.3 Perl Package Upgrades">
<link href="ch-module_packages.html#s-indep_modules" rel="subsection" title="4.4.1 Architecture-Independent Modules">
<link href="ch-module_packages.html#s-binary_modules" rel="subsection" title="4.4.2 Binary and Other Architecture Dependent Modules">
<link href="ch-module_packages.html#s-dh_perl" rel="subsection" title="4.4.3 Automating Perl Dependencies">

</head>

<body>

<p><a name="ch-embed"></a></p>
<hr>

<p>
[ <a href="ch-programs.html">previous</a> ]
[ <a href="index.html#contents">Contents</a> ]
[ <a href="ch1.html">1</a> ]
[ <a href="ch-perl.html">2</a> ]
[ <a href="ch-site.html">3</a> ]
[ <a href="ch-module_packages.html">4</a> ]
[ <a href="ch-programs.html">5</a> ]
[ 6 ]
[ <a href="ap-perl6.html">A</a> ]
[ <a href="ap-perl6.html">next</a> ]
</p>

<hr>

<h1>
Debian Perl Policy
<br>Chapter 6 - Programs Embedding Perl
</h1>

<hr>

<h2 id="s-build_embedded">6.1 Building Embedded Programs</h2>

<p>
Programs which embed a perl interpreter must declare a
<samp>Build-Depends</samp> on <code>libperl-dev</code>.
</p>

<p>
The default linker options produced by
</p>

<pre>
     perl -MExtUtils::Embed -e ldopts
</pre>

<p>
will link against the dynamic <samp>libperl</samp>.  If programs wish to link
to the static library, then <samp>-lperl</samp> should be changed to
<code>/usr/lib/libperl.a</code> in those options.
</p>

<hr>

<h2 id="s-embedded_deps">6.2 Embedded Perl Dependencies</h2>

<p>
Dependencies for programs linking against the shared Perl library will be
automatically created by <code>dpkg-shlibdeps</code>.  Note however that the
shared perl library package only suggests <code>perl-base</code> and packages
requiring any <var>core</var> modules from the <code>perl</code> package must
depend upon it explicitly.
</p>

<hr>

<h2 id="s-perl_upgrades">6.3 Perl Package Upgrades</h2>

<p>
Starting from <code>perl</code> 5.12.3-2, a dpkg trigger named
<var>perl-major-upgrade</var> will be triggered by the postinst of the
<code>perl</code> package during major upgrades.  Some examples of things which
constitute a major upgrade are an upgrade which would change the value of
versioned directories in <samp>@INC</samp>, or one which changes
<samp>abiname</samp>.  Any package may declare an interest in the trigger,
especially packages including long-running daemons which would stop working
until restart.
</p>

<p>
It is suggested that such packages include an appropriate section in their
postinst to handle the trigger by restarting relevant daemons or notifying
users of further action.
</p>

<hr>

<p>
[ <a href="ch-programs.html">previous</a> ]
[ <a href="index.html#contents">Contents</a> ]
[ <a href="ch1.html">1</a> ]
[ <a href="ch-perl.html">2</a> ]
[ <a href="ch-site.html">3</a> ]
[ <a href="ch-module_packages.html">4</a> ]
[ <a href="ch-programs.html">5</a> ]
[ 6 ]
[ <a href="ap-perl6.html">A</a> ]
[ <a href="ap-perl6.html">next</a> ]
</p>

<hr>

<p>
Debian Perl Policy
</p>

<address>
version 3.9.8.0, 2016-03-30<br>
<br>
Rapha&euml;l Hertzog<br>
Brendan O'Dea<br>
The Debian Policy mailing list <code><a href="mailto:debian-policy@lists.debian.org">mailto:debian-policy@lists.debian.org</a></code><br>
<br>
</address>
<hr>

</body>

</html>

